﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HeuristicLab.Collections;
using HeuristicLab.Core;
using HeuristicLab.Encodings.IntegerVectorEncoding;
using HeuristicLab.Encodings.PackingEncoding.GroupingVector;
using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
using HeuristicLab.Encodings.PackingEncoding.PackingSequence;
using HeuristicLab.Problems.BinPacking.Dimensions;
using HeuristicLab.Problems.BinPacking.Interfaces;
using HeuristicLab.Problems.BinPacking.PackingBin;
using HeuristicLab.Problems.BinPacking.PackingItem;
using HeuristicLab.Problems.BinPacking.Shapes;

namespace HeuristicLab.Problems.BinPacking.Decoders {
  public static class ExtremePointsFunctions<D,B,I>
    where D : class, IPackingDimensions
    where B : PackingShape<D>, IPackingBin, IRegularPackingShape
      where I : PackingShape<D>, IPackingItem, IRegularPackingShape {


    public static ObservableDictionary<int, D> ExtremePointBasedPacking(IItem solution, B binMeasures, ItemList<I> itemMeasures) {
      var actualSolutionMCV = solution as MultiComponentVectorEncoding;
      var actualSolutionGV = solution as GroupingVectorEncoding;    
      var actualSolutionPS = solution as PackingSequenceEncoding;
      if (actualSolutionMCV != null)
        return ExtremePointBasedPacking(actualSolutionMCV, binMeasures, itemMeasures);
      else if (actualSolutionGV != null)
        return ExtremePointBasedPacking(actualSolutionGV, binMeasures, itemMeasures);
      else  if (actualSolutionPS != null)
        return ExtremePointBasedPacking(actualSolutionPS, binMeasures, itemMeasures);
      else
        return new ObservableDictionary<int,D>();
    }

    public static ObservableDictionary<int, D> ExtremePointBasedPacking(MultiComponentVectorEncoding solution, B binMeasures, ItemList<I> itemMeasures) {

    }

    public static ObservableDictionary<int, D> ExtremePointBasedPacking(GroupingVectorEncoding solution, B binMeasures, ItemList<I> itemMeasures) {

    }

    public static ObservableDictionary<int, D> ExtremePointBasedPacking(PackingSequenceEncoding solution, B binMeasures, ItemList<I> itemMeasures) {

    }
    
  }
}
